
;place PROTO near beginning of file

Arbitrary2Str PROTO   :DWORD,:DWORD,:DWORD

;----------------------------------------------------------------------------------

        OPTION  EPILOGUE:NONE
        OPTION  PROLOGUE:NONE

Arbitrary2Str PROC lpFirstDword:DWORD,dwNmberOfDwords:DWORD,lpResultStringEnd:DWORD
;
; CONVERT ARBITRARY NUMBER TO ASCII DECIMAL STRING
;
;original 16-bit code by Richard Pavlicek
;modified for 32-bit by DednDave (revision 3)
;
;a fast, compact routine that will convert a big number to ASCII decimal
;
;Usage:
;       INVOKE  Arbitrary2Str,
;               lpFirstDword,
;               dwNumberOfDwords,
;               lpResultStringEnd
;
;     lpFirstDword = offset of input value
; dwNumberOfDwords = number of dwords in input value
;lpResultStringEnd = offset of end of result string + 1 (null terminator)
;
;Returns: eax = pointer to first byte of ASCII decimal string
;         ecx = number of decimal digits
;
;---------------------------------------------

;set up the stack frame

        push    ebx
        push    esi
        push    edi
        push    ebp
        mov     ebp,esp           ;stack frame pointer
        mov     esi,[ebp+20]      ;first parm - source
        mov     ecx,[ebp+24]      ;second parm - dword count
        mov     edi,[ebp+28]      ;third parm - destination

;adjust source pointer to last dword

        mov     eax,ecx           ;dword count in eax
        dec     eax               ;minus 1
        shl     eax,2             ;x4 = bytes
        add     esi,eax           ;point to last dword

;set up for first pass relocation

        mov     ebx,4             ;dword adjustment size
        add     eax,ebx           ;input value size in bytes
        sub     esp,eax           ;make room on the stack
        push    ebp               ;save stack frame pointer
        sub     ebp,ebx           ;ebp points to last dword

;outer loop

A2Str0: push    ecx               ;save dword count
        push    ebp               ;save high pointer
        sub     edi,8             ;make room for 8 decimal digits
        mov     ebx,100000000     ;100 million
        xor     edx,edx           ;initial remainder

;inner loop divides by 100 million

A2Str1: mov     eax,[esi]         ;get dword of dividend
        div     ebx               ;divide by 100 million
        mov     [ebp],eax         ;save quotient
        sub     esi,4             ;move to next dword
        sub     ebp,4             ;ebp as well
        dec     ecx               ;done ?
        jnz     A2Str1            ;no - repeat

;continuation of outer loop

        mov     eax,edx           ;remainder (0-99999999)
        sub     edx,edx           ;extend for division
        mov     ebx,10000         ;divisor to make 4-digit groups
        div     ebx               ;dx = 0-9999, ax = 0-9999
        mov     bl,100            ;divisor to make 2-digit groups
        div     bl                ;ah = 0-99, al = 0-99
        mov     ecx,eax           ;save al
        mov     al,ah             ;least significant 2 digits
        aam                       ;ah = 0-9, al = 0-9
        bswap   eax               ;reverse and save in upper half of eax
        mov     al,cl             ;recall al
        aam                       ;ah = 0-9, al = 0-9
        xchg    al,ah             ;reverse order
        or      eax,30303030h     ;make ASCII
        mov     [edi],eax         ;most significant 4 digits
        mov     ax,dx             ;least significant (0-9999)
        div     bl                ;ah = 0-99, al = 0-99
        mov     ecx,eax           ;save al
        mov     al,ah             ;least significant 2 digits
        aam                       ;ah = 0-9, al = 0-9
        bswap   eax               ;reverse and save in upper half of eax
        mov     al,cl             ;recall al
        aam                       ;ah = 0-9, al = 0-9
        xchg    al,ah             ;reverse order
        or      eax,30303030h     ;make ASCII
        mov     [edi+4],eax       ;least significant 4 digits
        pop     ebp               ;restore high dword pointer
        mov     esi,ebp           ;after first pass, esi = ebp
        pop     ecx               ;restore dword count
        cmp dword ptr [ebp],0     ;is high dword zeroed yet?
        jnz     A2Str0            ;no, continue with same count

        sub     ebp,4             ;yes, point to next dword
        mov     esi,ebp           ;after first pass, esi = ebp
        dec     ecx               ;reduce dword count
        jnz     A2Str0            ;until done

;suppress leading 0's

        pop     ebp               ;recall the stack frame pointer
        mov     al,'0'            ;check for leading zeros to cleanup
        mov     cl,8              ;maximum needed to check
        repz    scasb             ;advances edi past first non-zero digit
        dec     edi               ;point to first non-zero digit in string

;set return values

        mov     ecx,[ebp+28]      ;recall string tail pointer
        xchg    eax,edi           ;eax = offset of ASCII string
        sub     ecx,eax           ;ecx = number of ASCII digits

;restore registers and exit

        leave                     ;mov esp,ebp - pop ebp
        pop     edi
        pop     esi
        pop     ebx
        ret     12                ;ret and discard 3 dwords

Arbitrary2Str ENDP

        OPTION  EPILOGUE:EpilogueDef
        OPTION  PROLOGUE:PrologueDef

;----------------------------------------------------------------------------------
